diff --git a/src/main/java/net/minecraft/client/gui/createworld/CreateWorldPageRegistry.java b/src/main/java/net/minecraft/client/gui/createworld/CreateWorldPageRegistry.java
index 58ce059ee..0465ce016 100644
--- a/src/main/java/net/minecraft/client/gui/createworld/CreateWorldPageRegistry.java
+++ b/src/main/java/net/minecraft/client/gui/createworld/CreateWorldPageRegistry.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.createworld;
 import net.minecraft.client.gui.paged.Page;
 import net.minecraft.client.gui.paged.PageRegistry;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 
 public class CreateWorldPageRegistry
@@ -13,9 +14,9 @@ public class CreateWorldPageRegistry
         return INSTANCE;
     }
 
-    public static final Page GENERAL = INSTANCE.register(new Page("gui.create_world.pages.general.title", new ItemStack(Item.map)))
+    public static final Page GENERAL = INSTANCE.register(new Page("gui.create_world.pages.general.title", new ItemStack(Items.MAP)))
         .withComponent(new TextFieldComponent("gui.create_world.pages.general.label.world_name"))
         .withComponent(new TextFieldComponent("gui.create_world.pages.general.label.world_seed"));
-    public static final Page WORLD_SETTINGS = INSTANCE.register(new Page("gui.create_world.pages.world_settings.title", new ItemStack(Item.dustRedstone)));
-    public static final Page GAME_RULES = INSTANCE.register(new Page("gui.create_world.pages.game_rules.title", new ItemStack(Item.book)));
+    public static final Page WORLD_SETTINGS = INSTANCE.register(new Page("gui.create_world.pages.world_settings.title", new ItemStack(Items.DUST_REDSTONE)));
+    public static final Page GAME_RULES = INSTANCE.register(new Page("gui.create_world.pages.game_rules.title", new ItemStack(Items.BOOK)));
 }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java b/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
index e1f9157ce..e78e5077d 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
@@ -16,6 +16,7 @@ import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
@@ -23,6 +24,7 @@ import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
 import java.util.List;
+import java.util.Random;
 
 public class GuiGuidebook
     extends GuiScreen {
@@ -41,6 +43,9 @@ public class GuiGuidebook
     private final GuiTooltip tooltip = new GuiTooltip(Minecraft.getMinecraft(this));
     private Tab[] tabs = new Tab[TABS_PER_SIDE * 2];
 
+    private GuidebookPage lastPage = null;
+    private boolean canPlaySound = true;
+
     public GuiGuidebook() {
         super();
 
@@ -137,6 +142,7 @@ public class GuiGuidebook
 
     @Override
     public void drawScreen(int mouseX, int mouseY, float renderPartialTicks) {
+        lastPage = pageManager.getLeftPage();
         scroll(Mouse.getDWheel());
 
         int xOffset = 0;
@@ -166,6 +172,7 @@ public class GuiGuidebook
             }
         }
         pageManager.offsetPage(MathHelper.clamp(-direction, -1, 1) * 2 * count);
+        playPageSound();
         updateTabList();
     }
 
@@ -176,11 +183,13 @@ public class GuiGuidebook
         // Handle back button
         if (mouseButton == 3) {
             pageManager.goBack();
+            playPageSound();
             updateTabList();
             return;
         }
         if (mouseButton == 4) {
             pageManager.goForward();
+            playPageSound();
             updateTabList();
             return;
         }
@@ -203,11 +212,13 @@ public class GuiGuidebook
         if (pageManager.getLeftPage() != null && pageManager.hasPreviousPage()) {
             if (mouseX >= left && mouseX <= left + size && mouseY >= top && mouseY <= top + size) {
                 pageManager.offsetPage(-2);
+                playPageSound();
                 updateTabList();
                 return;
             }
             if (mouseX >= left && mouseX <= left + size && mouseY >= bottom - size && mouseY <= bottom) {
                 pageManager.offsetPage(-2);
+                playPageSound();
                 updateTabList();
                 return;
             }
@@ -215,11 +226,13 @@ public class GuiGuidebook
         if (pageManager.getRightPage() != null && pageManager.hasNextPage()) {
             if (mouseX >= right - size && mouseX <= right && mouseY >= top && mouseY <= top + size) {
                 pageManager.offsetPage(2);
+                playPageSound();
                 updateTabList();
                 return;
             }
             if (mouseX >= right - size && mouseX <= right && mouseY >= bottom - size && mouseY <= bottom) {
                 pageManager.offsetPage(2);
+                playPageSound();
                 updateTabList();
                 return;
             }
@@ -280,11 +293,20 @@ public class GuiGuidebook
             if (tab == null) return;
             if (tab.mouseOver(mouseX, mouseY)) {
                 pageManager.setCurrentPage(pageManager.getSectionIndex(tab.getSection()), true);
+                playPageSound();
                 updateTabList();
                 return;
             }
         }
     }
+
+    private void playPageSound() {
+        if (!canPlaySound || lastPage == pageManager.getLeftPage()) return;
+        canPlaySound = false;
+        Random r = new Random();
+        mc.sndManager.playSound("random.page", SoundCategory.GUI_SOUNDS, 0.8f, 0.9f + (r.nextFloat() - r.nextFloat()) * 0.1f);
+    }
+
     public void guiSpecificControllerInput(ControllerInput controller){
         if (controller.digitalPad.left.pressedThisFrame() || (controller.digitalPad.left.isPressed() && controller.digitalPad.left.getHoldTime() % 4 == 0)){
             pageManager.offsetPage(-2);
@@ -294,7 +316,7 @@ public class GuiGuidebook
             pageManager.offsetPage(2);
             updateTabList();
         }
-        if (controller.buttonR.pressedThisFrame()){
+        if (controller.buttonRightShoulder.pressedThisFrame()){
             Tab t = getTab(pageManager.getCurrentSection(), true);
             if (t != null){
                 int currentPage = pageManager.getPageIndex(pageManager.getLeftPage());
@@ -305,7 +327,7 @@ public class GuiGuidebook
                 updateTabList();
             }
         }
-        if (controller.buttonL.pressedThisFrame()){
+        if (controller.buttonLeftShoulder.pressedThisFrame()){
             Tab t = getTab(pageManager.getCurrentSection(), false);
             if (t != null){
                 int currentPage = pageManager.getPageIndex(pageManager.getLeftPage());
@@ -346,6 +368,8 @@ public class GuiGuidebook
     public void tick() {
         super.tick();
 
+        canPlaySound = true;
+
         if (pageManager.getLeftPage() != null) {
             pageManager.getLeftPage().onTick();
         }
@@ -434,7 +458,7 @@ public class GuiGuidebook
         int left = width / 2 - xSize / 2 + xOffset;
         int right = width / 2 + xSize / 2 + xOffset;
 
-        mc.renderEngine.bindTexture(mc.renderEngine.getTexture("/assets/minecraft/textures/gui/guidebook/guidebook.png"));
+        mc.renderEngine.bindTexture(mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
 
         GL11.glColor4f(1, 1, 1, 1);
         if (pageManager.getLeftPage() != null && pageManager.hasPreviousPage()) {
@@ -493,7 +517,7 @@ public class GuiGuidebook
         public void render(RenderEngine re, FontRenderer fr, int mouseX, int mouseY) {
             boolean mouseOver = mouseOver(mouseX, mouseY);
 
-            re.bindTexture(re.getTexture("/assets/minecraft/textures/gui/guidebook/guidebook.png"));
+            re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
 
             int xo = 16;
             if (mouseOver || active) {
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
index 796332b4e..e3bad2858 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
@@ -21,7 +21,7 @@ public abstract class GuidebookPage
 
     protected void renderBackground(RenderEngine re, int x, int y) {
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        re.bindTexture(re.getTexture("/assets/minecraft/textures/gui/guidebook/guidebook.png"));
+        re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
         drawTexturedModalRect(x, y, 0, 0, width, height);
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookSections.java b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookSections.java
index f62b658c5..bf32c9e2f 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookSections.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookSections.java
@@ -9,6 +9,7 @@ import net.minecraft.client.gui.guidebook.smelting.BlastSmeltingSection;
 import net.minecraft.client.gui.guidebook.smelting.SmeltingSection;
 import net.minecraft.client.gui.guidebook.trommeling.TrommelSection;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
 
 import java.util.ArrayList;
@@ -36,9 +37,9 @@ public abstract class GuidebookSections {
         INDEX = register(new IndexSection());
         SEARCH = register(new SearchSection());
         CRAFTING = register(new CraftingSection());
-        FURNACE = register(new SmeltingSection("guidebook.section.furnace", new ItemStack(Block.furnaceStoneActive), 0x606060, 0x404040));
-        BLAST_FURNACE = register(new BlastSmeltingSection("guidebook.section.blast_furnace", new ItemStack(Block.furnaceBlastActive), 0xA0A0A0, 0x808080));
-        TROMMEL = register(new TrommelSection("guidebook.section.trommel", new ItemStack(Block.trommelActive), 0x202020, 0x404040));
+        FURNACE = register(new SmeltingSection("guidebook.section.furnace", new ItemStack(Blocks.FURNACE_STONE_ACTIVE), 0x606060, 0x404040));
+        BLAST_FURNACE = register(new BlastSmeltingSection("guidebook.section.blast_furnace", new ItemStack(Blocks.FURNACE_BLAST_ACTIVE), 0xA0A0A0, 0x808080));
+        TROMMEL = register(new TrommelSection("guidebook.section.trommel", new ItemStack(Blocks.TROMMEL_ACTIVE), 0x202020, 0x404040));
         MOB = register(new MobSection());
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverPage.java b/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverPage.java
index ee980c743..ddc897956 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverPage.java
@@ -19,7 +19,7 @@ public class CoverPage
 
     @Override
     public void renderBackground(RenderEngine re, int x, int y) {
-        re.bindTexture(re.getTexture("/assets/minecraft/textures/gui/guidebook/cover.png"));
+        re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/cover.png"));
         drawTexturedModalRect(x, y, 0, 0, 158, 220);
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverSection.java b/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverSection.java
index 596dbd3ec..642e40d8c 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverSection.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/cover/CoverSection.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.guidebook.cover;
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
 
 import java.util.ArrayList;
@@ -13,7 +14,7 @@ public class CoverSection
     private final List<GuidebookPage> pages = new ArrayList<>();
 
     public CoverSection() {
-        super("guidebook.section.cover", new ItemStack(Block.motionsensorActive), 0xA42D29, 0xC29B1C);
+        super("guidebook.section.cover", new ItemStack(Blocks.MOTION_SENSOR_ACTIVE), 0xA42D29, 0xC29B1C);
 
         pages.add(new CoverPage(this));
     }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
index 3c5101454..ac8937515 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
@@ -12,15 +12,15 @@ import net.minecraft.client.gui.guidebook.RecipePage;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.RenderEngine;
-import net.minecraft.core.achievement.AchievementList;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShapeless;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotGuidebook;
+import net.minecraft.core.player.inventory.slot.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -33,12 +33,12 @@ public class CraftingPage
     extends RecipePage<RecipeEntryCrafting<?,?>> {
     public static final int RECIPES_PER_PAGE = 3;
 
-    public List<SlotGuidebook> slots;
-    public Map<RecipeEntryCrafting<?,?>,List<SlotGuidebook>> map;
+    public List<GuidebookSlot> slots;
+    public Map<RecipeEntryCrafting<?,?>,List<GuidebookSlot>> map;
     private final GuiTooltip guiTooltip;
     private final GuiRenderItem guiRenderItem;
     private static final Minecraft mc = Minecraft.getMinecraft(GuidebookPage.class);
-    private static EntityPlayer player;
+    private static Player player;
     private static long ticks = 0;
 
     public CraftingPage(GuidebookSection section, List<RecipeEntryCrafting<?,?>> recipes) {
@@ -47,14 +47,14 @@ public class CraftingPage
         this.slots = new ArrayList<>();
         this.map = new HashMap<>();
         player = mc.thePlayer;
-        player.addStat(AchievementList.OPEN_GUIDEBOOK,1);
+        player.addStat(Achievements.OPEN_GUIDEBOOK,1);
         guiTooltip = new GuiTooltip(mc);
         guiRenderItem = new GuiRenderItem(mc);
         int recipeAmount = 0;
         int xOffset = 32;
         int yOffset = 12;
         for (RecipeEntryCrafting<?,?> recipe : recipes) {
-            List<SlotGuidebook> recipeSlots = new ArrayList<>();
+            List<GuidebookSlot> recipeSlots = new ArrayList<>();
             if (recipe instanceof RecipeEntryCraftingShaped)
             {
                 final RecipeEntryCraftingShaped r = (RecipeEntryCraftingShaped) recipe;
@@ -71,17 +71,17 @@ public class CraftingPage
 
                         if (slotX >= r.recipeWidth || slotY >= r.recipeHeight)
                         {
-                            recipeSlots.add(new SlotGuidebook(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, null, false,recipe));
+                            recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, null, false,recipe));
                         }
                         else
                         {
                             RecipeSymbol stack = r.getInput()[slotX + (slotY * r.recipeWidth)];
-                            recipeSlots.add(new SlotGuidebook(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, stack, false,recipe));
+                            recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, stack, false,recipe));
                         }
                     }
 
-                    int centerY = (recipeSlots.get(recipeSlots.size()-1).yDisplayPosition + recipeSlots.get(recipeSlots.size()-8).yDisplayPosition) / 2;
-                    recipeSlots.add(new SlotGuidebook(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput().copy()), false,recipe).setAsOutput());
+                    int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-8).y) / 2;
+                    recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput().copy()), false,recipe).setAsOutput());
 
                     map.put(recipe,recipeSlots);
                     slots.addAll(recipeSlots);
@@ -99,17 +99,17 @@ public class CraftingPage
 
                         if (slotX >= r.recipeWidth || slotY >= r.recipeHeight)
                         {
-                            recipeSlots.add(new SlotGuidebook(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, null, false,recipe));
+                            recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, null, false,recipe));
                         }
                         else
                         {
                             RecipeSymbol stack = r.getInput()[slotX + (slotY * r.recipeWidth)];
-                            recipeSlots.add(new SlotGuidebook(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, stack, false,recipe));
+                            recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, stack, false,recipe));
                         }
                     }
 
-                    int centerY = (recipeSlots.get(recipeSlots.size()-1).yDisplayPosition + recipeSlots.get(recipeSlots.size()-3).yDisplayPosition) / 2;
-                    recipeSlots.add(new SlotGuidebook(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput()), false,recipe).setAsOutput());
+                    int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
+                    recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput()), false,recipe).setAsOutput());
 
                     map.put(recipe,recipeSlots);
                     slots.addAll(recipeSlots);
@@ -130,15 +130,15 @@ public class CraftingPage
                     for (int i = 0; i < Math.max(r.getInput().size(),9); i++)
                     {
                         if(i >= r.getInput().size()){
-                            recipeSlots.add(new SlotGuidebook(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, null, false,recipe));
+                            recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, null, false,recipe));
                             continue;
                         }
                         RecipeSymbol stack = r.getInput().get(i);
-                        recipeSlots.add(new SlotGuidebook(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, stack, false,recipe));
+                        recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, stack, false,recipe));
                     }
 
-                    int centerY = (recipeSlots.get(recipeSlots.size()-1).yDisplayPosition + recipeSlots.get(recipeSlots.size()-8).yDisplayPosition) / 2;
-                    recipeSlots.add(new SlotGuidebook(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput()), false,recipe).setAsOutput());
+                    int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-8).y) / 2;
+                    recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput()), false,recipe).setAsOutput());
 
                     map.put(recipe,recipeSlots);
                     slots.addAll(recipeSlots);
@@ -151,15 +151,15 @@ public class CraftingPage
                     for (int i = 0; i < Math.max(r.getInput().size(),4); i++)
                     {
                         if(i >= r.getInput().size()){
-                            recipeSlots.add(new SlotGuidebook(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, null, false,recipe));
+                            recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, null, false,recipe));
                             continue;
                         }
                         RecipeSymbol stack = r.getInput().get(i);
-                        recipeSlots.add(new SlotGuidebook(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, stack, false,recipe));
+                        recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, stack, false,recipe));
                     }
 
-                    int centerY = (recipeSlots.get(recipeSlots.size()-1).yDisplayPosition + recipeSlots.get(recipeSlots.size()-3).yDisplayPosition) / 2;
-                    recipeSlots.add(new SlotGuidebook(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput()), false,recipe).setAsOutput());
+                    int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
+                    recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(r.getOutput()), false,recipe).setAsOutput());
 
                     map.put(recipe,recipeSlots);
                     slots.addAll(recipeSlots);
@@ -176,9 +176,9 @@ public class CraftingPage
         if(recipes.isEmpty()){
             drawStringCenteredNoShadow(fr,"No recipes found :(" ,x+width/2,y+height/2,0xFF808080);
         }
-        SlotGuidebook mouseOverSlot = null;
+        GuidebookSlot mouseOverSlot = null;
         ticks++;
-        for (SlotGuidebook slot : slots) {
+        for (GuidebookSlot slot : slots) {
             if(slot.item != null){
                 if(!slot.isOutput) slot.item.stackSize = 1;
             }
@@ -188,28 +188,28 @@ public class CraftingPage
                     ticks = 0;
                 }
             }
-            drawSlot(re,x+slot.xDisplayPosition-1,y+slot.yDisplayPosition-1,0xFFFFFFFF);
+            drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            guiRenderItem.render(slot.getStack(),x+slot.xDisplayPosition,y+slot.yDisplayPosition,mouseOverSlot == slot,slot);
+            guiRenderItem.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
         }
     }
 
     public boolean getIsMouseOverSlot(final Slot slot, int x, int y, int mouseX, int mouseY)
     {
-        return mouseX >= x+slot.xDisplayPosition - 1 && mouseX < x+slot.xDisplayPosition + 16 + 1 && mouseY >= y+slot.yDisplayPosition - 1 && mouseY < y+slot.yDisplayPosition + 16 + 1;
+        return mouseX >= x+slot.x - 1 && mouseX < x+slot.x + 16 + 1 && mouseY >= y+slot.y - 1 && mouseY < y+slot.y + 16 + 1;
     }
 
     @Override
     public void keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
         super.keyTyped(c, key, x, y, mouseX, mouseY);
         if(mc.gameSettings.keyShowRecipe.isKeyboardKey(key)){
-            SlotGuidebook hoveringSlot= null;
-            for (SlotGuidebook slot : slots) {
+            GuidebookSlot hoveringSlot= null;
+            for (GuidebookSlot slot : slots) {
                 if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) hoveringSlot = slot;
             }
             if(hoveringSlot != null){
-                if(hoveringSlot.hasStack()){
-                    String query = "r:"+hoveringSlot.getStack().getDisplayName()+"!";
+                if(hoveringSlot.hasItem()){
+                    String query = "r:"+hoveringSlot.getItem().getDisplayName()+"!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
                     GuiGuidebook.getPageManager().updatePages();
@@ -217,13 +217,13 @@ public class CraftingPage
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
-            SlotGuidebook hoveringSlot= null;
-            for (SlotGuidebook slot : slots) {
+            GuidebookSlot hoveringSlot= null;
+            for (GuidebookSlot slot : slots) {
                 if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) hoveringSlot = slot;
             }
             if(hoveringSlot != null) {
-                if (hoveringSlot.hasStack()) {
-                    String query = "u:" + hoveringSlot.getStack().getDisplayName() + "!";
+                if (hoveringSlot.hasItem()) {
+                    String query = "u:" + hoveringSlot.getItem().getDisplayName() + "!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
                     GuiGuidebook.getPageManager().updatePages();
@@ -242,25 +242,25 @@ public class CraftingPage
     @Override
     protected void renderBackground(RenderEngine re, int x, int y) {
         super.renderBackground(re, x, y);
-        re.bindTexture(re.getTexture("/assets/minecraft/textures/gui/guidebook/guidebook.png"));
+        re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
         for (int i = 1; i <= recipes.size(); i++) {
             RecipeEntryCrafting<?, ?> recipe = recipes.get(i-1);
-            List<SlotGuidebook> list = map.get(recipe);
-            drawTexturedModalRect(x + list.get(list.size()-1).xDisplayPosition - 25, y +  list.get(list.size()-1).yDisplayPosition, 234, 0, 22, 15);
+            List<GuidebookSlot> list = map.get(recipe);
+            drawTexturedModalRect(x + list.get(list.size()-1).x - 25, y +  list.get(list.size()-1).y, 234, 0, 22, 15);
         }
     }
 
     @Override
     protected void renderOverlay(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.renderOverlay(re, fr, x, y, mouseX, mouseY, partialTicks);
-        SlotGuidebook mouseOverSlot = null;
-        for (SlotGuidebook slot : slots) {
+        GuidebookSlot mouseOverSlot = null;
+        for (GuidebookSlot slot : slots) {
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            if (mouseOverSlot != null && mouseOverSlot.hasStack())
+            if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = guiTooltip.getTooltipText(mouseOverSlot.getStack(), showDescription, mouseOverSlot);
+                String str = guiTooltip.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
                     guiTooltip.render(str, mouseX, mouseY, 8, -8);
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingSection.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingSection.java
index f090884d0..9eb0887f0 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingSection.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingSection.java
@@ -2,9 +2,9 @@ package net.minecraft.client.gui.guidebook.crafting;
 
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.SearchableGuidebookSection;
-import net.minecraft.client.gui.guidebook.smelting.SmeltingPage;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShapeless;
@@ -23,7 +23,7 @@ public class CraftingSection
     private Pair<String,List<GuidebookPage>> filteredPages = null;
 
     public CraftingSection() {
-        super("guidebook.section.crafting", new ItemStack(Block.workbench), 0xA86335, 0xA52922);
+        super("guidebook.section.crafting", new ItemStack(Blocks.WORKBENCH), 0xA86335, 0xA52922);
         reloadRecipes();
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/index/IndexSection.java b/src/main/java/net/minecraft/client/gui/guidebook/index/IndexSection.java
index a5ac3ef7f..f65914977 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/index/IndexSection.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/index/IndexSection.java
@@ -3,8 +3,8 @@ package net.minecraft.client.gui.guidebook.index;
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
-import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 
 import java.util.ArrayList;
@@ -16,7 +16,7 @@ public class IndexSection
     private ArrayList<GuidebookPage> indexPages = null;
 
     public IndexSection() {
-        super("guidebook.section.index", new ItemStack(Item.toolCompass), 0x0094FF, 0xC29B1C);
+        super("guidebook.section.index", new ItemStack(Items.TOOL_COMPASS), 0x0094FF, 0xC29B1C);
     }
 
     @Override
